#include <stdio.h>
#include <stdlib.h>
#include <alloc.h>
#include <time.h>
#include <string.h>
#include <conio.h>
#include "mcga2.h"
#include "events.h"

#include "defs.h"

void	err();

BITBLK	*Nomatch, *Tblocked, *Notile, *Newgame, *Filegame, *Restgame,
	*Exitgame, *Cursor, *Undo, *Help, *dbMaster, *Endgame, *Prefs;

BITBLK	*s1, *s2, *s3, *s4, *f1, *f2, *f3, *f4;

BITBLK	**Digits,
	**Tiles,
	**Menu,
	**Signs,
	**DBLogo,
	**YingYang;

int	Field[15][8][5];
int	Sfield[15][8][5];
int	Cfield[15][8][5];
int	UndoStack[72][2][4];
int	Usp;

int	Stones[144] = {
	02,02,
	03,03,
	03,03,
	04,04,
	04,04,
	05,05,
	05,05,
	06,06,
	06,06,
	07,07,
	07,07,
	 8, 8,
	 8, 8,
	 9, 9,
	 9, 9,
	10,10,
	10,10,
	11,11,
	11,11,
	12,12,
	12,12,
	13,13,
	13,13,
	14,14,
	14,14,
	15,15,
	15,15,
	16,16,
	16,16,
	17,17,
	17,17,
	18,18,
	19,19,
	20,20,
	21,21,
	22,22,
	23,23,
	24,24,
	25,25,
	26,26,
	26,26,
	27,27,
	27,27,
	28,28,
	28,28,
	29,29,
	29,29,
	30,30,
	30,30,
	31,31,
	31,31,
	32,32,
	32,32,
	33,33,
	33,33,
	34,34,
	34,34,
	35,35,
	36,36,
	37,37,
	38,38,
	39,39,
	40,40,
	41,41,
	42,42,
	43,43,
	44,44,
	00,00,
	00,00,
	01,01,
	01,01,
	02,02,
};

int	pos[432], plist[432] = {
	1,	0, 	0,
	2,	0,	0,
	3,	0,	0,
	4,	0,	0,
	5,	0,	0,
	6,	0,	0,
	7,	0,	0,
	8,	0,	0,
	9,	0,	0,
	10,	0,	0,
	11,	0,	0,
	12,	0,	0,

	3,	1,	0,
	4,	1,	0,
	5,	1,	0,
	6,	1,	0,
	7,	1,	0,
	8,	1,	0,
	9,	1,	0,
	10,	1,	0,

	2,	2,	0,
	3,	2,	0,
	4,	2,	0,
	5,	2,	0,
	6,	2,	0,
	7,	2,	0,
	8,	2,	0,
	9,	2,	0,
	10,	2,	0,
	11,	2,	0,

	0,	3,	0,
	1,	3, 	0,
	2,	3,	0,
	3,	3,	0,
	4,	3,	0,
	5,	3,	0,
	6,	3,	0,
	7,	3,	0,
	8,	3,	0,
	9,	3,	0,
	10,	3,	0,
	11,	3,	0,
	12,	3,	0,
	13,	3,	0,
	14,	3,	0,

	1,	4, 	0,
	2,	4,	0,
	3,	4,	0,
	4,	4,	0,
	5,	4,	0,
	6,	4,	0,
	7,	4,	0,
	8,	4,	0,
	9,	4,	0,
	10,	4,	0,
	11,	4,	0,
	12,	4,	0,

	2,	5,	0,
	3,	5,	0,
	4,	5,	0,
	5,	5,	0,
	6,	5,	0,
	7,	5,	0,
	8,	5,	0,
	9,	5,	0,
	10,	5,	0,
	11,	5,	0,

	3,	6,	0,
	4,	6,	0,
	5,	6,	0,
	6,	6,	0,
	7,	6,	0,
	8,	6,	0,
	9,	6,	0,
	10,	6,	0,

	1,	7, 	0,
	2,	7,	0,
	3,	7,	0,
	4,	7,	0,
	5,	7,	0,
	6,	7,	0,
	7,	7,	0,
	8,	7,	0,
	9,	7,	0,
	10,	7,	0,
	11,	7,	0,
	12,	7,	0,

/*******************************/

	4,	1,	1,
	5,	1,	1,
	6,	1,	1,
	7,	1,	1,
	8,	1,	1,
	9,	1,	1,

	4,	2,	1,
	5,	2,	1,
	6,	2,	1,
	7,	2,	1,
	8,	2,	1,
	9,	2,	1,

	4,	3,	1,
	5,	3,	1,
	6,	3,	1,
	7,	3,	1,
	8,	3,	1,
	9,	3,	1,

	4,	4,	1,
	5,	4,	1,
	6,	4,	1,
	7,	4,	1,
	8,	4,	1,
	9,	4,	1,

	4,	5,	1,
	5,	5,	1,
	6,	5,	1,
	7,	5,	1,
	8,	5,	1,
	9,	5,	1,

	4,	6,	1,
	5,	6,	1,
	6,	6,	1,
	7,	6,	1,
	8,	6,	1,
	9,	6,	1,

/*******************************/

	5,	2,	2,
	6,	2,	2,
	7,	2,	2,
	8,	2,	2,

	5,	3,	2,
	6,	3,	2,
	7,	3,	2,
	8,	3,	2,

	5,	4,	2,
	6,	4,	2,
	7,	4,	2,
	8,	4,	2,

	5,	5,	2,
	6,	5,	2,
	7,	5,	2,
	8,	5,	2,

/*******************************/

	6,	3,	3,
	7,	3,	3,
	6,	4,	3,
	7,	4,	3,

	6,	3,	4

/*******************************/
};

/*	GLOBALS	*/

int	Tiles_left = -1;
int	Mx, My, Mz,
	Mtile;
int	Cx, Cy;
int	Allow_undo;
int	Mastermode;
int	SafeBoards;


BITBLK **tryload(name)
char	*name;
{
	BITBLK	**bb;

	putc('.', stderr);
	if ((bb = mcga_zload(name)) == NULL) {
		fprintf(stderr, " Cannot load: %s\n", name);
		err();
		exit(2);
	}
	return(bb);
}


void initgr() {
	fprintf(stderr, "Loading ...");
	if (mcga_loadzfont("fnt07x07.dat", 15, 1) < 0) {
		fprintf(stderr, " Cannot load: fnt07x07.dat\n");
		err();
		exit(2);
	}
	Tiles = tryload("sym20x23.dat");
	s1 = Tiles[22]; s2 = Tiles[23]; s3 = Tiles[24]; s4 = Tiles[25];
	f1 = Tiles[35]; f2 = Tiles[36]; f3 = Tiles[37]; f4 = Tiles[38];

	Digits = tryload("sym10x10.dat");
	Cursor = Digits[10];

	Menu = tryload("sym30x15.dat");
	Newgame = Menu[0];
	Filegame = Menu[1];
	Restgame = Menu[2];
	Exitgame = Menu[3];
	Undo = Menu[4];
	Help = Menu[5];

	Signs = tryload("sym30x10.dat");
	Nomatch = Signs[0];
	Tblocked = Signs[1];
	Notile = Signs[2];

	DBLogo = tryload("sym16x16.dat");
	dbMaster = *DBLogo;
	Prefs = DBLogo[1];

	YingYang = tryload("sym50x50.dat");
	Endgame = *YingYang;

	if (initmcga() == -1) {
		fprintf(stderr, "No MCGA Adapter detected.\n");
		exit(2);
	}

	clear();
}


void endgr() {
	endmcga();
	if (_mouse_installed) _mouse_softcsr();
}



BITBLK *getbb(x, y, sx, sy)
int  x, y, sx, sy;
{
	static BITBLK	new;
	static char	buf[100];

	new.cols = sx;
	new.rows = sy;
	new.stream = buf;
	mcgagetbb(x, y, &new);

	return(&new);
}


/********** [ MAIN PROGRAM ] ***********/


void err() {
	putchar('\a');
}


void init()
{
   int  x, y, z;
   int	i, t, r1, r2;

   memcpy((int *) &pos, (int *) &plist, sizeof(plist));

   for (z=0; z<5; z++)
	for (x=0; x<15; x++)
	   for (y=0; y<8; y++)
		Field[x][y][z] = -1;

   for (i=0; i<100; i++) {
	r1 = random(143);
	r2 = random(143);
	t = Stones[r1]; Stones[r1] = Stones[r2]; Stones[r2] = t;
	t = Stones[r1+1]; Stones[r1+1] = Stones[r2+1]; Stones[r2+1] = t;
   }

   Usp = 0;
}


void rrboard()
{
   int  r1, r2, sx, sy, sz;
   int  i;
   FILE *t;

   for (i=0; i<200; i++) {
	r1 = random(144) * 3;
	r2 = random(144) * 3;
	sx = pos[r1]; sy = pos[r1+1]; sz = pos[r1+2];
	pos[r1] = pos[r2]; pos[r1+1] = pos[r2+1];
	pos[r1+2] = pos[r2+2];
	pos[r2] = sx; pos[r2+1] = sy; pos[r2+2] = sz;
   }

   for (i=0; i<144; i++)
	Field[pos[i*3]][pos[i*3+1]][pos[i*3+2]] = Stones[i];

   if ((t = fopen(THISBOARD, "wb")) == NULL)
	return;
   fwrite((char *) &Field, 1, sizeof(Field), t);
   fclose(t);
}


void srboard() {
   struct list {
	int	*p;
	int	n;
   } ef[144];
   int  r1, r2, sx, sy, sz;
   int  i, j, last, next;
   FILE *t;

   for (i=0; i<200; i++) {
	r1 = random(144) * 3;
	r2 = random(144) * 3;
	sx = pos[r1]; sy = pos[r1+1]; sz = pos[r1+2];
	pos[r1] = pos[r2]; pos[r1+1] = pos[r2+1];
	pos[r1+2] = pos[r2+2];
	pos[r2] = sx; pos[r2+1] = sy; pos[r2+2] = sz;
   }

   for (i=0; i<144; i++) {
	ef[i].p = &pos[i*3];
	ef[i].n = i+1;
   }
   ef[last = 143].n = -1;

   i = j = 0;
   while (i<144) {
	if (	ef[j].p[2] != 0 &&
		Field[ef[j].p[0]][ef[j].p[1]][ef[j].p[2]-1] == -1
		||
		ef[j].p[2] == 4 && i != 143
	) {
		ef[last].n = j;
		last = j;
		next = ef[j].n;
		ef[j].n = -1;
		j = next;
	}
	else {
		Field[ef[j].p[0]][ef[j].p[1]][ef[j].p[2]] = Stones[i++];
		j = ef[j].n;
	}
   }

   if ((t = fopen(THISBOARD, "wb")) == NULL)
	return;
   fwrite((char *) &Field, 1, sizeof(Field), t);
   fclose(t);
}


void rboard() {
   SafeBoards? srboard(): rrboard();
}


void shade(x, y, c)
int  x, y, c;
{
   int  i;

   for (i=1; i<DEPTH-1; i++)
	pixel(x-i, y+i, c);
   pixel(x-i, y+i, 26);
}


void border(x, dx, y, dy, z)
int  x, dx, y, dy;
{
   int  i;

   shade(x*20+DEPTH*z+dx, y*23-z*DEPTH+dy, 26);
   for (i=1; i<22; i++)
	shade(x*20+DEPTH*z+dx, y*23-z*DEPTH+dy+i, 18);
   shade(x*20+DEPTH*z+dx, y*23-z*DEPTH+dy+22, 26);
   for (i=1; i<19; i++)
	shade(x*20+DEPTH*z+dx+i, y*23-z*DEPTH+dy+22, 18);
   shade(x*20+DEPTH*z+dx+19, y*23-z*DEPTH+dy+22, 26);
}


void drawtile(x, y, z, tile)
int  x, y, z, tile;
{
   int  dx = DEPTH, dy = 0;

   if (x == 0 || x > 12 || z == 4)
	dy += 11;
   if (z == 4)
	dx += 10;
   bitblt(x*20+z*DEPTH+dx, y*23-z*DEPTH+dy, Tiles[tile], B_COPY, 0);
   border(x, dx, y, dy, z);
}


void _drawboard(f)
int	(*f)[8][5];
{
   int  x, y, z;

   for (z=0; z<5; z++)
	for (x=14; x>=0; x--)
	   for (y=0; y<8; y++)
		if (f[x][y][z] != -1)
		   if (z == 3 || z == 4)
			drawtile(x, y, z, f[x][y][z]);
		   else if (f[x][y][z+1] == -1)
			drawtile(x, y, z, f[x][y][z]);
}


void drawboard()
{
   _drawboard(Field);
   if (!Tiles_left)
	bitblt(135, 75, Endgame, B_COPY, 0);
}


void _left(n) {
   char  s[4];
   int   i;

   sprintf(s, "%03d", n);
   for (i=0; i<3; i++)
	bitblt(309, i*10, Digits[s[i]-'0'], B_COPY, 0);
}


void left() {
	_left(Tiles_left);
}


void redraw()
{
   if (Mtile == -1)
	return;
   Mtile = -1;
   clear();
   drawboard();
   left();
}


int blocked(x, y, z)
int  x, y, z;
{
   if (z == 4)	return(0);

   if (Field[x][y][z+1] != -1)
	return(1);

   if (x < 1)	return(0);
   if (x > 13)	return(0);
   if (x == 13) {
	if (Field[14][3][0] == -1)
	   return(0);
	return(1);
   }
   if ((x == 6 || x == 7) && (y == 3 || y == 4) && z == 3) {
	if (Field[6][3][4] == -1)
	   return(0);
	return(1);
   }
   if (x == 1 && (y == 3 || y == 4)) {
	if (Field[0][3][0] == -1)
	   return(0);
	return(1);
   }
   if (x == 12 && (y == 3 || y == 4)) {
	if (Field[13][3][0] == -1)
	   return(0);
	return(1);
   }

   if (Field[x-1][y][z] == -1 || Field[x+1][y][z] == -1)
	return(0);

   return(1);
}


void skip()
{
   for (;;) {
	if (kbhit()) {
	   if (getch() == 0)
		getch();
	   return;
	}
	if (_mouse_button()) {
	   while (_mouse_button())
		;
	   return;
	}
   }
}


void dont(n)
int  n;
{
   switch (n) {
	case 0:	bitblt(269, 40, Tblocked, B_COPY, 0); break;
	case 1:	bitblt(269, 40, Nomatch, B_COPY, 0); break;
	case 2:	bitblt(269, 40, Notile, B_COPY, 0); break;
   }
   skip();
   box(269, 40, 299, 50, 1);
}


int match(t1, t2)
int  t1, t2;
{
   if (t1 >= 22 && t1 <= 25 && t2 >= 22 && t2 <= 25)
	return(1);
   if (t1 >= 35 && t1 <= 38 && t2 >= 35 && t2 <= 38)
	return(1);
   if (t1 == t2)
	return(1);
   return(0);
}


void savetodb()
{
   FILE  *db, *tmp;
   int   cn;
   unsigned   rd;

   if ((tmp = fopen(THISBOARD, "rb")) == NULL) {
	err();
	return;
   }

   if ((db = fopen(BOARDDB, "r+b")) == NULL) {
	if ((db = fopen(BOARDDB, "w+b")) == NULL) {
	   fclose(tmp);
	   err();
	   return;
	}
	else {
	   cn = 1;
	   fwrite((int *) &cn, 1, sizeof(cn), db);
	}
   }
   else {
	fread((int *) &cn, 1, sizeof(cn), db);
	rewind(db);
	cn++;
   }

   fseek(db, (long) sizeof(cn), SEEK_SET);
   fread((char *) &Sfield, 1, sizeof(Sfield), tmp);
   rd = fread((char *) &Cfield, 1, sizeof(Cfield), db);
   while (rd == sizeof(Cfield)) {
	if (!memcmp((char *) &Sfield, (char *) &Cfield, sizeof(Sfield))) {
	   fclose(db);
	   fclose(tmp);
	   return;
	}
	rd = fread((char *) &Cfield, 1, sizeof(Cfield), db);
   }

   clearerr(db);
   fseek(db, 0L, SEEK_END);
   fwrite((char *) &Sfield, 1, sizeof(Sfield), db);

   rewind(db);
   fwrite((int *) &cn, 1, sizeof(cn), db);

   fclose(tmp);
   fclose(db);
}


void congrats()
{
   bitblt(135, 75, Endgame, B_COPY, 0);
   savetodb();
}


void frame(x, y, z)
int x, y, z;
{
   int  dx = DEPTH, dy = 0;

   bitblt(260, 125, Tiles[Field[x][y][z]], B_COPY, 0);
   _hline(259, 124, 280, 52);
   _hline(259, 148, 280, 52);
   _vline(259, 124, 148, 52);
   _vline(280, 124, 148, 52);

   if (blocked(x, y, z)) {
	dont(0);
	redraw();
	return;
   }

   if (x == 0 || x > 12 || z == 4)
	dy += 11;
   if (z == 4)
	dx += 10;
   _hline(x*20+z*DEPTH+dx, y*23-z*DEPTH+dy, x*20+z*DEPTH+dx+19, 39);
   _hline(x*20+z*DEPTH+dx, y*23-z*DEPTH+dy+22, x*20+z*DEPTH+dx+19, 39);
   _vline(x*20+z*DEPTH+dx+19, y*23-z*DEPTH+dy, y*23-z*DEPTH+dy+22, 39);
   _vline(x*20+z*DEPTH+dx, y*23-z*DEPTH+dy, y*23-z*DEPTH+dy+22, 39);

   if (Mtile == -1) {
	Mtile = Field[x][y][z];
	Mx = x;
	My = y;
	Mz = z;
	return;
   }

   if (x == Mx && y == My && z == Mz) {
	redraw();
	return;
   }

   if (match(Mtile, Field[x][y][z])) {
	UndoStack[Usp][0][0] = Field[x][y][z];
	UndoStack[Usp][0][1] = x;
	UndoStack[Usp][0][2] = y;
	UndoStack[Usp][0][3] = z;
	UndoStack[Usp][1][0] = Field[Mx][My][Mz];
	UndoStack[Usp][1][1] = Mx;
	UndoStack[Usp][1][2] = My;
	UndoStack[Usp][1][3] = Mz;
	Usp++;
	Field[x][y][z] = -1;
	Field[Mx][My][Mz] = -1;
	Tiles_left -= 2;
   }
   else
	dont(1);
   redraw();

   if (!Tiles_left)
	congrats();
}


void mark()
{
   if (Field[Cx][Cy][top(Cx, Cy)] == -1) {
	dont(2);
	return;
   }
   frame(Cx, Cy, top(Cx, Cy));
}


void enterpanel()
{
   box(288, 124, 319, 188, 15);
   bitblt(289, 125, Newgame, B_COPY, 0);
   bitblt(289, 141, Filegame, B_COPY, 0);
   bitblt(289, 157, Restgame, B_COPY, 0);
   bitblt(289, 173, Exitgame, B_COPY, 0);
}


void leavepanel()
{
   box(288, 124, 319, 188, 1);
}


void enterp2()
{
   box(288, 0, 319, 32, 15);
   bitblt(289, 1, Help, B_COPY, 0);
   bitblt(289, 17, Undo, B_COPY, 0);
}


void leavep2()
{
   box(288, 0, 319, 32, 1);
   left();
}


void entermaster()
{
   bitblt(0, 0, dbMaster, B_COPY, 15);
}


void leavemaster()
{
   box(0, 0, 16, 16, 1);
}


void enterprefs()
{
   bitblt(0, 173, Prefs, B_COPY, 15);
}


void leaveprefs()
{
   box(0, 173, 16, 189, 1);
}


void click()
{
   int  mx, my, x, y;

   while (_mouse_button())
	;

   _get_mousepos(&mx, &my);
   mx = mx / 2;
   if (mx >= 259 && mx <= 280 && my >= 124 && my <= 148) {
	box(259, 124, 280, 148, 1);
	return;
   }
   if (my >= 184 || mx >= 305) {
	dont(2);
	return;
   }
   if (mx >= 156 && mx <= 172 && my >= 61 && my < 81) {
	if (Field[6][3][4] != -1) {
	   frame(6, 3, 4);
	   return;
	}
   }
   if (mx >= 141 && mx <= 178 && my >= 55 && my <= 98) {
	x = mx - (3*DEPTH);
	y = my + (3*DEPTH);
	x = x / 20;
	y = y / 23;
	if (Field[x][y][3] != -1) {
	   frame(x, y, 3);
	   return;
	}
   }
   if (mx >= 116 && mx <= 192 && my >= 37 && my <= 126) {
	x = mx - (2*DEPTH);
	y = my + (2*DEPTH);
	x = x / 20;
	y = y / 23;
	if (Field[x][y][2] != -1) {
	   frame(x, y, 2);
	   return;
	}
   }
   if (mx >= 90 && mx <= 208 && my >= 19 && my <= 155) {
	x = mx - DEPTH;
	y = my + DEPTH;
	x = x / 20;
	y = y / 23;
	if (Field[x][y][1] != -1) {
	   frame(x, y, 1);
	   return;
	}
   }

   mx -= DEPTH;
   mx = mx / 20;
   my = my / 23;
   if (Field[mx][my][0] != -1) {
	frame(mx, my, 0);
	return;
   }

   dont(2);
}


int confirm(x, y, dx, dy)
int  x, y, dx, dy;
{
   int  mx, my;
   int	r;

   clearbuttons();
   clearpanels();
   dfl_event = (void (*)()) 0L;

   _hline(x/2, y, dx/2, 39);
   _hline(x/2, dy, dx/2, 39);
   _vline(x/2, y, dy, 39);
   _vline(dx/2, y, dy, 39);

   for (r = -1; r == -1; ) {
	switch (getevent()) {
	   case 'y':
	   case 'Y':
	   case '\r':	r = 1; break;
	   case 'n':
	   case 'N':
	   case ESC:	r = 0; break;
	   default:	if (!_mouse_button())
			   break;
			while (_mouse_button())
			   ;
			_get_mousepos(&mx, &my);
			if (mx >= x && mx <= dx && my >= y && my <= dy)
			   r = 1;
			else
			   r = 0;
	}
   }
   leavepanel();
   leavep2();
   leavemaster();
   return(r);
}


void newgame()
{
   init();
   rboard();
   Tiles_left = 144;
   clear();
   drawboard();
   left();
}


void filegame()
{
   FILE  *save, *tmp;

   if ((tmp = fopen(THISBOARD, "rb")) == NULL) {
	err();
	return;
   }

   if ((save = fopen(SAVEFILE, "wb")) == NULL) {
	fclose(tmp);
	err();
	return;
   }

   fread((char *) &Sfield, 1, sizeof(Sfield), tmp);
   fwrite((char *) &Sfield, 1, sizeof(Sfield), save);
   fwrite((char *) &Field, 1, sizeof(Field), save);
   fwrite((char *) &UndoStack, 1, sizeof(UndoStack), save);
   fwrite((int *) &Usp, 1, sizeof(Usp), save);

   fclose(save);
   fclose(tmp);
}


void restoregame()
{
   FILE  *save, *tmp;
   int   x, y, z;

   if ((save = fopen(SAVEFILE, "rb")) == NULL) {
	err();
	return;
   }

   if ((tmp = fopen(THISBOARD, "wb")) == NULL) {
	fclose(save);
	err();
	return;
   }

   fread((char *) &Sfield, 1, sizeof(Sfield), save);
   fwrite((char *) &Sfield, 1, sizeof(Sfield), tmp);
   fread((char *) &Field, 1, sizeof(Field), save);
   fread((char *) &UndoStack, 1, sizeof(UndoStack), save);
   fread((int *) &Usp, 1, sizeof(Usp), save);

   fclose(tmp);
   fclose(save);

   for (Tiles_left = 0, x=0; x<15; x++)
	for (y=0; y<8; y++)
	   for (z=0; z<5; z++)
		if (Field[x][y][z] != -1)
		   Tiles_left++;

   clear();
   drawboard();
   left();
}


int top(x, y)
int  x, y;
{
   int  z;

   for (z=1; z<5; z++)
	if (Field[x][y][z] == -1)
	   break;
   return(z-1);
}


void cursor(on)
int  on;
{
   int  dx = DEPTH, dy = 0, z;
   static BITBLK  *backgrd;

   if (Cx == 0 || Cx > 12 || top(Cx, Cy) == 4)
	dy += 11;
   if ((z = top(Cx, Cy)) == 4)
	dx += 10;

   if (on) {
	backgrd = (BITBLK *) getbb(Cx*20+z*DEPTH+dx, Cy*23-z*DEPTH+dy, 10, 10);
	mcgaovlbb(Cx*20+z*DEPTH+dx, Cy*23-z*DEPTH+dy, 0, Cursor);
   }
   else {
	bitblt(Cx*20+z*DEPTH+dx, Cy*23-z*DEPTH+dy, backgrd, B_COPY, 0);
   }
}


void terms2() {
   bputs(0, 0, " NAH-JONGG 2.2    BY NILS M. HOLM, 1997");
   _hline(0, 10, 319, 39);
   bputs(0, 3, "THIS SOFTWARE IS PROVIDED BY THE AUTHOR");
   bputs(0, 4, "AND CONTRIBUTORS ``AS IS'' AND ANY");
   bputs(0, 5, "EXPRESS OR IMPLIED WARRANTIES,");
   bputs(0, 6, "INCLUDING, BUT NOT LIMITED TO, THE");
   bputs(0, 7, "IMPLIED WARRANTIES OF MERCHANTABILITY");
   bputs(0, 8, "AND FITNESS FOR A PARTICULAR PURPOSE ARE");
   bputs(0, 9, "DISCLAIMED. IN NO EVENT SHALL THE AUTHOR");
   bputs(0, 10, "OR CONTRIBUTORS BE LIABLE FOR ANY");
   bputs(0, 11, "DIRECT, INDIRECT, INCIDENTAL, SPECIAL,");
   bputs(0, 12, "EXEMPLARY, OR CONSEQUENTIAL DAMAGES");
   bputs(0, 13, "(INCLUDING, BUT NOT LIMITED TO,");
   bputs(0, 14, "PROCUREMENT OF SUBSTITUTE GOODS OR");
   bputs(0, 15, "SERVICES; LOSS OF USE, DATA, OR PROFITS;");
   bputs(0, 16, "OR BUSINESS INTERRUPTION) HOWEVER CAUSED");
   bputs(0, 17, "AND ON ANY THEORY OF LIABILITY, WHETHER");
   bputs(0, 19, "IN CONTRACT, STRICT LIABILITY, OR TORT");
   bputs(0, 20, "(INCLUDING NEGLIGENCE OR OTHERWISE)");
   bputs(0, 21, "ARISING IN ANY WAY OUT OF THE USE OF");
   bputs(0, 22, "THIS SOFTWARE, EVEN IF ADVISED OF THE");
   bputs(0, 23, "POSSIBILITY OF SUCH DAMAGE.");
   getevent();
   while (_mouse_button())
   	;
   clear();
}


void terms() {
   bputs(0, 0, " NAH-JONGG 2.2    BY NILS M. HOLM, 1997");
   _hline(0, 10, 319, 39);
   bputs(0, 3, "L I C E N S E");
   bputs(0, 5, "Redistribution and use in source and");
   bputs(0, 6, "binary forms, with or without");
   bputs(0, 7, "modification, are permitted provided");
   bputs(0, 8, "that the following conditions are met:");

   bputs(0, 10, "1. Redistributions of source code must");
   bputs(0, 11, "retain the above copyright notice,");
   bputs(0, 12, "this list of conditions and the");
   bputs(0, 13, "following disclaimer.");

   bputs(0, 15, "2. Redistributions in binary form must");
   bputs(0, 16, "reproduce the above copyright notice,");
   bputs(0, 17, "this list of conditions and the");
   bputs(0, 18, "following disclaimer in the");
   bputs(0, 19, "documentation and/or other materials");
   bputs(0, 20, "provided with the distribution.");
   bputs(0, 22, "-- Press mouse button for page 2 --");
   getevent();
   while (_mouse_button())
   	;
   clear();

   terms2();
}


void help2() {
   bputs(0, 0, " NAH-JONGG 2.2    BY NILS M. HOLM, 1997");
   _hline(0, 10, 319, 39);
   bputs(0, 2, " Keyboard Controls:");
   bputs(0, 5, "   \030   Use the arrow keys to");
   bputs(0, 6, "  \033 \032  move the cursor onto");
   bputs(0, 7, "   \031   the desired tile.");
   bputs(0,10, "  <ENTER>  mark/unmark a tile.");
   bputs(0,12, "  <S> <R>  save/restore game.");
   bputs(0,14, "  <N>      create new random board.");
   bputs(0,16, "  <u>      undo last move (game must");
   bputs(0,18, "           run with the -u option).");
   bputs(0,20, "  <M>      enter game database.");
   bputs(0,22, "  <ESC>    quit game.");
   bitblt(260, 40, s1, B_COPY, 0);
   mcgaovlbb(260, 40, 0, Cursor);
   getevent();
   while (_mouse_button())
   	;
   clear();
}


void help()
{
   clear();
   bputs(0, 0, " NAH-JONGG 2.2    BY NILS M. HOLM, 1997");
   _hline(0, 10, 319, 39);

   bitblt(8, 70, f1, B_COPY, 0);
   bitblt(28, 70, f2, B_COPY, 0);
   bitblt(48, 70, f3, B_COPY, 0);
   bitblt(68, 70, f4, B_COPY, 0);
   bputs(12, 10, "Flowers");
   bitblt(160, 70, s1, B_COPY, 0);
   bitblt(180, 70, s2, B_COPY, 0);
   bitblt(200, 70, s3, B_COPY, 0);
   bitblt(220, 70, s4, B_COPY, 0);
   bputs(31, 10, "Seasons");

   box(8, 104, 39, 168, 15);
   bitblt(9, 105, Newgame, B_COPY, 0);
   bitblt(9, 121, Filegame, B_COPY, 0);
   bitblt(9, 137, Restgame, B_COPY, 0);
   bitblt(9, 153, Exitgame, B_COPY, 0);
   box(160, 104, 191, 136, 15);
   bitblt(161, 105, Help, B_COPY, 0);
   bitblt(161, 121, Undo, B_COPY, 0);

   bputs(6, 13, "New board");
   bputs(6, 15, "Save game");
   bputs(6, 17, "Restore game");
   bputs(6, 19, "Exit");
   bputs(25, 13, "This screen");
   bputs(25, 15, "Undo last move");
   bputs(0, 2, " Use the mouse or the cursor keys and");
   bputs(0, 3, " <ENTER> to mark  two matching tiles.");
   bputs(0, 4, " Flowers match flowers, seasons match");
   bputs(0, 5, " seasons, all other tiles match them-");
   bputs(0, 6, " selves.");
   box(158, 150, 256, 160, MWHITE);
   box(159, 151, 255, 159, MBLUE);
   bputs(20,19, "SHOW LICENSE");
   bputs(20,21, "Press mouse button");
   bputs(20,22, "for more help.");
   clearbuttons();
   addbutton(316, 150, 512, 160, 'L', 0, 0);
   if (getevent() == 'L') {
	clear();
	terms();
	return;
   }
   while (_mouse_button())
   	;
   clear();

   help2();
}


int undo()
{
   int  x, y, z;

   if (Usp < 1 || !Allow_undo)
	return(-1);

   Usp--;
   x = UndoStack[Usp][0][1];
   y = UndoStack[Usp][0][2];
   z = UndoStack[Usp][0][3];
   Field[x][y][z] = UndoStack[Usp][0][0];

   x = UndoStack[Usp][1][1];
   y = UndoStack[Usp][1][2];
   z = UndoStack[Usp][1][3];
   Field[x][y][z] = UndoStack[Usp][1][0];
   Tiles_left += 2;

   return(0);
}


void play()
{
   int  c;

   rboard();
   drawboard();

   Tiles_left = 144;
   Mtile = -1;
   left();

   for (;;) {
	if (_mouse_installed) {
	   clearbuttons();
	   clearpanels();
	   addpanel(576, 124, 639, 189, enterpanel, leavepanel);
	   addbutton(576, 125, 639, 140, 'N', 0, 0);
	   addbutton(576, 141, 639, 156, 'S', 0, 0);
	   addbutton(576, 157, 639, 172, 'R', 0, 0);
	   addbutton(576, 173, 639, 188, ESC, 0, 0);
	   addpanel(576, 0, 639, 32, enterp2, leavep2);
	   addbutton(576, 0, 639, 16, '?', 0, 0);
	   addbutton(576, 17, 639, 32, 'u', 0, 0);
	   if (Mastermode) {
		addpanel(0, 0, 32, 16, entermaster, leavemaster);
		addbutton(0, 0, 32, 16, 'M', 0, 0);
	   }
	   addpanel(0, 173, 32, 189, enterprefs, leaveprefs);
	   addbutton(0, 173, 32, 189, 'P', 0, 0);
	   dfl_event = click;
	}

	if (!_mouse_installed)
	   cursor(1);

	c = getevent();

	if (!_mouse_installed)
	   cursor(0);

	switch (c) {
	   case 'N':	if (!_mouse_installed)
			   enterpanel();
			if (confirm(576, 124, 639, 140))
			   newgame();
			if (!_mouse_installed)
			   leavepanel();
			break;
	   case 'S':	if (!_mouse_installed)
			   enterpanel();
			if (confirm(576, 141, 639, 156))
			   filegame();
			if (!_mouse_installed)
			   leavepanel();
			break;
	   case 'R':	if (!_mouse_installed)
			   enterpanel();
			if (confirm(576, 157, 639, 172))
			   restoregame();
			if (!_mouse_installed)
			   leavepanel();
			break;
	   case ESC:	if (!_mouse_installed)
			   enterpanel();
			if (confirm(576, 173, 639, 188))
			   return;
			if (!_mouse_installed)
			   leavepanel();
			break;

	   case 315:
	   case '?':	if (!_mouse_installed)
			   enterp2();
			if (c == 315 || confirm(576, 0, 639, 16)) {
			   help();
			   drawboard();
			   left();
			}
			if (!_mouse_installed)
			   leavep2();
			break;

	   case 'u':	if (!_mouse_installed)
			   enterp2();
			if (confirm(576, 17, 639, 32))
			   if (!undo()) {
				clear();
				drawboard();
				left();
			   }
			   else
				err();
			if (!_mouse_installed)
			   leavep2();
			break;

	   case 'M':	dbmain(); clear(); drawboard(); left(); break;

	   case 'P':	preferences(); clear(); drawboard(); left(); break;

	   case ext(77):if (++Cx > 14) Cx = 0; break;
	   case ext(75):if (--Cx < 0) Cx = 14; break;
	   case ext(72):if (--Cy < 0) Cy = 7; break;
	   case ext(80):if (++Cy > 7) Cy = 0; break;

	   case '\r':	mark(); break;
	}
   }
}


void usage(name)
char	*name;
{
	printf("Usage: %s [-Hhmu]\n\n"
	"\t-?  print this text\n"
	"\t-h  print help before starting\n"
	"\t-m  disable mouse\n"
	"\t-u  enable undo (cheating!)\n",
	strrchr(name, '\\')+1);
}


int main(argc, argv)
int   argc;
char  **argv;
{
   int  i, j;
   int	nomouse = 0,
	header = 0;

   Mastermode = 1;
   SafeBoards = 1;
   for (i=1; argv[i][0] == '-'; i++)
	for (j=1; argv[i][j]; j++)
	   switch(argv[i][j]) {
		case 'H':	SafeBoards = 0; break;
		case 'h':	header = 1; break;
		case 'm':	nomouse = 1; break;
		case 'u':	Allow_undo = 1; break;
		default:	usage(argv[0]);
				exit(0);
	   }

   initgr();

   event_init();
   if (_mouse_installed && !nomouse) {
	init_mouse(0, 0, 639, 199);
	_mouse_hardcsr();
   }
   else {
	_mouse_installed = 0;
	Cx = Cy = 0;
   }

   randomize();
   delay(0);

   if (header) help();

   init();
   play();

   endgr();
   unlink(THISBOARD);
   return(0);
}
